package c7_7;

public class GrafickeUtvary {

//	public static int pocet(Utvar[] u, Class Typ) { // s čistým typom
	public static int pocet(Utvar[] utvary, Class<? extends Utvar> typUtvaru) { // s využitím generickosti

		int n = 0;
		for (Utvar utvar : utvary) {
			if (typUtvaru.isInstance(utvar)) {
				n++;
			}
		}

		return n;
	}

	public static int pocetPresne(Utvar[] utvary, Class<? extends Utvar> typUtvaru) {

		int n = 0;
		for (Utvar utvar : utvary) {
			if (utvar.getClass().equals(typUtvaru)) { // Dynamicke zistenie za behu
				n++;
			}
		}

		return n;
	}

	public static int vratPocetElips(Utvar[] utvary) {

		int n = 0;
		for (Utvar utvar : utvary) {
			if (utvar instanceof Elipsa) { // Musi byt jasne uz pri compileovani
				n++;
			}
		}

		return n;
	}

	public static void main(String args[]) {
		Utvar[] utvary = {
				new Trojuholnik(),
				new Kruh(),
				new Kruh(),
				new Elipsa(),
				new Elipsa(),
				new Elipsa()
		};

		int pocetElips = pocet(utvary, Elipsa.class);
		System.out.println("Pocet elips: " + pocetElips); // preco?

		pocetElips = vratPocetElips(utvary);
		System.out.println("Pocet elips {static): " + pocetElips);

		pocetElips = pocetPresne(utvary, Elipsa.class);
		System.out.println("Pocet elips presne bez potomkov (dynamic): " + pocetElips);

		int pocetKruhov = pocet(utvary, Kruh.class);
		System.out.println(
				String.format("Pocet kruhov: %d", pocetKruhov)
		);
	}

}