package c7_2;

public class Values {

	static int i = 0;
	static int j = 0;

	static synchronized void increment() { // Synchronizovana metoda
		i++;
		j++;
	}

	static void print() {
		synchronized(Values.class) { // Synchronizacia nad objektom
			if (i != j) {
				System.out.println("i=" + i + " j=" + j);
			}
		}
	}

	public static void main(String[] args) {
		new Incrementer().start();
		new Printer().start();
	}

}