package model.rytier;

import model.Energia;
import model.mec.Mec;
import model.obor.Obor;

public class Rytier implements Energia {

	protected Integer energia;
	protected Mec mec;

	public Rytier(int energia, Mec mec) {
		this.energia = energia;
		this.mec = mec;
	}

	@Override
	public void nastavEnergiu(int energia) {
		this.energia = energia;
	}

	@Override
	public void znizEnergiu(int energia) {
		this.energia -= energia;
	}

	@Override
	public int vratEnergiu() {
		return energia;
	}

	public void utoc(Obor obor) {
		mec.udri(obor, this);
		obor.odveta(this);
	}

}